
*MoveCamera

	proj_near = 100.0 : proj_far = meshsize * meshxz0 : proj_fov = 60.0
	E3DSetProjection proj_near, proj_far, proj_fov

	if keybuf.VK_UP = 1 {
		E3DPosForward hsid_cur, forwardstep
		E3DGetPos hsid_cur, saveposx1, saveposy1, saveposz1
		slope = saveposy1 - saveposy0 - jump
		if slope > 100.0 {
			back = -50.0
			if slope > 150.0 : back -= 50.0
			if slope > 180.0 : back -= 80.0
			E3DPosForward hsid_cur, back
			if slope > 200.0 : E3DSetPos hsid_cur, saveposx0, saveposy0, saveposz0
		}
	}
	if keybuf.VK_DOWN = 1 : E3DPosForward hsid_cur, backstep
	if keybuf.VK_LEFT = 1 {
		E3DRotateY hsid_cur, -degstep
		if keybuf.VK_DOWN = 0: E3DPosForward hsid_cur, forwardstep/3
	}
	if keybuf.VK_RIGHT = 1 {
		E3DRotateY hsid_cur, degstep
		if keybuf.VK_DOWN = 0: E3DPosForward hsid_cur, forwardstep/3
	}
	if keybuf.VK_PRIOR  = 1 : cam_offset += 1
	if keybuf.VK_NEXT = 1 : if cam_offset > 2 : cam_offset -= 1

	k=0
	if keybuf.'A' = 1 : k+=1 
	if keybuf.'W' = 1 : k+=2 
	if keybuf.'D' = 1 : k+=4 
	if keybuf.'S' = 1 : k+=8

	if k&1 : camdegxz += deg : smoothxz = deg
	if k&4 : camdegxz -= deg : smoothxz =-deg
	if k&2 : camdegy += deg : smoothy = deg
	if k&8 : camdegy -= deg : smoothy =-deg

	if( camdegxz > 360.0 ){
		camdegxz -= 360.0
	}
	if( camdegxz < 0.0 ) {
		camdegxz += 360.0
	}
	if( camdegy >= 60.0 ){
		camdegy = 59.0
	}
	if( camdegy <= -60.0 ){
		camdegy = -59.0
	}

	E3DGetPos hsid_cur, saveposx0, saveposy0, saveposz0
	E3DSetPos hsid_shadow, saveposx0, saveposy0 + 50.0 - jump, saveposz0
	E3DSetPos hsid_sky, saveposx0, saveposy0, saveposz0

	if smoothxz ! 0.0 : smoothxz *= 0.8 : camdegxz += smoothxz
	if smoothy  ! 0.0 : smoothy  *= 0.8 : camdegy  += smoothy

	E3DSin camdegxz, sinxz
	E3DCos camdegxz, cosxz
	E3DSin camdegy, siny
	E3DCos camdegy, cosy

	camposx = sinxz * cosy * cameradist + saveposx0
	camposy = eye_y + siny * cameradist + saveposy0 - jump
	camposz = -cosxz * cosy * cameradist + saveposz0

	E3DSetCameraPos camposx, camposy + ( 200.0*cam_offset), camposz
	E3DSetCameraTarget saveposx0, saveposy0 + eye_y - jump, saveposz0, 0.0, 1.0, 0.0

	if nowmotid = motid2 { ; 胂[V̏㉺
		// frameno1  sin ɕϊ
		theta = 0.0
		val = 0.0
		jump = 0.0
		val = 1.0 * (frameno1 -10)
			if frameno1 > 30 : val = 1.0 * (frameno1 - 40)
		theta = val / 30.0 * 3.14
		jump = 220.0 * sin(theta)
		if jump < 0.0 : jump *= -1
		jump -= 30.0
		if jump < 0.0 : jump = 0.0
	} else {
		jump = 0.0
	}

	return


*ChkConf
	result0 = 0
	confgid = 0
	repeat meshnum
	 	E3DChkConfGround hsid_cur, gid.cnt, 1, 20000.0, -100.0, result0, adjustx0, adjusty0, adjustz0, nx0, ny0, nz0
		if ( result0 != 0 ){
			E3DSetPos hsid_cur, adjustx0, adjusty0 + jump, adjustz0
			break
		}
		confgid++
	loop
return
